/*
 * Copyright (C) 2010 Apple Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */
 

#include "config.h"
#include <wtf/RunLoop.h>

#include <wtf/WindowsExtras.h>

namespace WTF {

extern thread_local Thread::ThreadHolder s_threadHolder;	/*TELESCOPE_LIB_CHANGES 7/27/2020 declare s_threadHolder*/

void RunLoop::run()
{
    //assert(0);
}

void RunLoop::stop()
{
    //assert(0);
}

RunLoop::RunLoop()
{
	//assert( 0 );
}

RunLoop::~RunLoop()
{
	//assert( 0 );
}

void RunLoop::wakeUp()
{
    //assert(0);
}

//+TELESCOPE_LIB_CHANGES
//8/3/2020
//shutdown s_threadHolder
void RunLoop::shutdown()
{
    s_threadHolder.shutdown();
}
//-TELESCOPE_LIB_CHANGES
RunLoop::CycleResult RunLoop::cycle(RunLoopMode)
{
    //assert(0);
    return CycleResult::Continue;
}

RunLoop::TimerBase::TimerBase(RunLoop& runLoop)
    : m_runLoop(runLoop)
{
	//assert( 0 );
}

RunLoop::TimerBase::~TimerBase()
{
    //assert(0);
    stop();
}

void RunLoop::TimerBase::start(Seconds nextFireInterval, bool repeat)
{
    //assert(0);
}

void RunLoop::TimerBase::stop()
{
    //assert(0);
}

bool RunLoop::TimerBase::isActive(const AbstractLocker&) const
{
    //assert(0);
    return true;
}

bool RunLoop::TimerBase::isActive() const
{
    //assert(0);
    return true;
}

Seconds RunLoop::TimerBase::secondsUntilFire() const
{
    //assert(0);
    return 0_s;
}



} // namespace WTF
